//finds the unserviced town nearest to the location inputted
function find_nearby_town(location,serviced_towns) {
   AILog.Info("Finding unserviced town near " + location);

   //create a list of potential towns
	local towns = AITownList();

   //remove serviced towns
   towns.RemoveList(serviced_towns);

   //remove towns that are too small to make a profit
   towns.Valuate(AITown.GetPopulation);
   towns.KeepAboveValue(100);

   //keep the closest town to the inputted location on the list
   towns.Valuate(AITown.GetDistanceManhattanToTile, location);
   towns.KeepBottom(1);
   AILog.Info("Town found at " + AITown.GetLocation(towns.Begin()));
   return(towns.Begin());
   
}

//finds a town with population < 1100
function find_small_town() {
	AILog.Info("Finding a town..");
	
	//create a list of all the unserviced towns between 250 and 1100 population.
	AILog.Info("Searching for a small town...");
	local town_list = AITownList();
	town_list.RemoveList(serviced_towns);
	town_list.Valuate(AITown.GetPopulation);
	town_list.KeepAboveValue(250);
	town_list.KeepBelowValue(1100);
	AILog.Info("Number of potential towns: " + town_list.Count());
	
	//choose the largest town in this list
	town_list.KeepTop(1);
	AILog.Info("Town Found! Building network...");
	local town = town_list.Begin();
	return(town);

}
